<?php

namespace App\Controller\Api;

use App\Entity\Client;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Attribute\Route;

class SearchController extends AbstractController
{
    #[Route('/search', methods: ['GET'])]
    public function index(Request $request, EntityManagerInterface $entityManager): Response
    {
        $filters = $request->query->get('filters');
        if ($filters) {
            $filters = json_decode($filters, true);
        }

        $repository = $entityManager->getRepository(Client::class);
        $queryBuilder = $repository->createQueryBuilder('e');

        if (!empty($filters)) {
            foreach ($filters as $field => $value) {
                $queryBuilder->andWhere("e.$field = :$field")
                    ->setParameter($field, $value);
            }
        }

        $results = $queryBuilder->getQuery()->getResult();

        return new JsonResponse($results);
    }
}
